// JVSDKDEMODlg.cpp : implementation file
//

#include "stdafx.h"
#include "JVSDKDEMO.h"
#include "JVSDKDEMODlg.h"
#include "JVSDK.h"
#pragma comment(lib,"JVSDK.lib")
#include "config.h"
#include "full.h"
#include "JvsSock.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define JVS_MAX_DATA_SIZE	1024*400
//ݸSDK֪ͨ¼SDKҪӦó֪ͨʱʹô¼֪ͨͲμJVSDK.h
#define WM_SDK_NOTIFY		WM_USER + 0x600

CONFIG g_config;


void FuncGetDataCallback(int nChannel, PUCHAR pData, UINT nBuffLen, PUCHAR pData2, UINT nBuffLen2, int nFrameType, BOOL bMov);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJVSDKDEMODlg dialog

CJVSDKDEMODlg::CJVSDKDEMODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJVSDKDEMODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJVSDKDEMODlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	memset(&g_config, 0, sizeof(CONFIG));
	m_nCurSel = 0;
	m_bInit	=	FALSE;
	m_pSocket = NULL;
}

void CJVSDKDEMODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJVSDKDEMODlg)
	DDX_Control(pDX, IDC_COMBO_MODE, m_comboMode);
	DDX_Control(pDX, IDC_LIST_INFO, m_lstInfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CJVSDKDEMODlg, CDialog)
	//{{AFX_MSG_MAP(CJVSDKDEMODlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_PREVIEW, OnButtonOpenPreview)
	ON_BN_CLICKED(IDC_BUTTON_STOP_PREVIEW, OnButtonStopPreview)
	ON_BN_CLICKED(IDC_BUTTON_START_COMPRESS, OnButtonStartCompress)
	ON_BN_CLICKED(IDC_BUTTON_STOP_COMPRESS, OnButtonStopCompress)
	ON_BN_CLICKED(IDC_BUTTON_WRITE, OnButtonWrite)
	ON_BN_CLICKED(IDC_BUTTON_STOP_WRITE, OnButtonStopWrite)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE_OSD, OnButtonEnableOsd)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE_OSD, OnButtonDisableOsd)
	ON_BN_CLICKED(IDC_BUTTON_QP, OnButtonQp)
	ON_BN_CLICKED(IDC_BUTTON_FULL_SCREEN, OnButtonFullScreen)
	ON_WM_MOVE()
	ON_BN_CLICKED(IDC_BUTTON_BITMAP, OnButtonBitmap)
	ON_BN_CLICKED(IDC_BUTTON_NETWORK, OnButtonNetwork)
	ON_BN_CLICKED(IDC_CHECK_MOV_DETECT, OnCheckMovDetect)
	ON_BN_CLICKED(IDC_CHECK_AUDIO_PREVIEW, OnCheckAudioPreview)
	ON_BN_CLICKED(IDC_CHECK_AUDIO_COMPRESS, OnCheckAudioCompress)
	ON_BN_CLICKED(IDC_BUTTON_SET_MODE, OnButtonSetMode)
	ON_BN_CLICKED(IDC_BUTTON_CAP_FILE, OnButtonCapFile)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SDK_NOTIFY, OnSDKNotify)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJVSDKDEMODlg message handlers

BOOL CJVSDKDEMODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//ʼSDK
	CString s;
	g_config.nTotalChannel = JVS_InitSDK();
	if (g_config.nTotalChannel == 0)
	{
		m_lstInfo.AddString("ûп");
	}
	else
	{
		s.Format("ͨ%dΪʾĿǰֻʹ1·", g_config.nTotalChannel);
		m_lstInfo.AddString(s);
		g_config.nTotalChannel = 1;

		//ڴͨǰʼSDKԴ
		//ʼԤԴ
		if (JVS_InitPreview() == TRUE)
		{
			g_config.bInitPreview = TRUE;
			m_lstInfo.AddString("ʼԤɹ");
		}
		else
		{
			g_config.bInitPreview = FALSE;
			m_lstInfo.AddString("ʼԤʧ");
		}
		//ʼѹԴ
		JVS_InitCompress();

		//עص
		JVS_RegisterCallBack(FuncGetDataCallback);

		//ƵźʱͼƬ
		JVS_SetNoSignalFile("CIF.bmp");
		//עSDK֪ͨ¼
		JVS_RegisterNotify(this->GetSafeHwnd(), WM_SDK_NOTIFY);
	}
	//
	SetDlgItemInt(IDC_EDIT_QP, 1);
	SetDlgItemInt(IDC_EDIT_MOV_GRADE, 30);
	SetDlgItemInt(IDC_EDIT_MOV_THRESHOLD, 30);
	m_comboMode.SetCurSel(0);

	g_config.Channel[0].fAnalyse = NULL;


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CJVSDKDEMODlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CJVSDKDEMODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CJVSDKDEMODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CJVSDKDEMODlg::OnButtonOpen() 
{
	// TODO: Add your control notification handler code here

	if (g_config.nTotalChannel == 1)
	{
		g_config.Channel[0].bOpened = JVS_OpenChannel(0);
		if (g_config.Channel[0].bOpened)
		{
			m_lstInfo.AddString("ͨ0");
			g_config.Channel[0].dwPixelMode = m_comboMode.GetCurSel();
			JVS_SetVideoPixelMode(0, m_comboMode.GetCurSel());
		}
	}
}

void CJVSDKDEMODlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	if (g_config.bInitPreview)
	{
		JVS_ReleasePreview();
		g_config.bInitPreview = FALSE;
	}
	JVS_ReleaseCompress();

	if (g_config.Channel[0].bOpened)
	{
		JVS_CloseChannel(0);
		g_config.Channel[0].bOpened = FALSE;
	}

	if (g_config.Channel[0].fout)
	{
		fclose(g_config.Channel[0].fout);
		g_config.Channel[0].fout = NULL;
	}

	//رsocket
	if (m_pSocket)
	{
		g_config.Channel[0].bTransmitting = FALSE;
		g_config.Channel[0].hSocket = NULL;
		CJvsSock * pSocket = (CJvsSock *)m_pSocket;
		pSocket->SendCloseSignal();
		pSocket->Close();
		delete pSocket;
		m_pSocket = NULL;
	}

	if (g_config.Channel[0].fAnalyse)
	{
		fclose(g_config.Channel[0].fAnalyse);
		g_config.Channel[0].fAnalyse	= NULL;
	}

	//ͷSDK
	JVS_ReleaseSDK();
}

void CJVSDKDEMODlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

void CJVSDKDEMODlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	DestroyWindow();
}

void CJVSDKDEMODlg::OnButtonClose() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened)
	{
		JVS_CloseChannel(0);
		g_config.Channel[0].bOpened = FALSE;
		g_config.Channel[0].bVideoPreview = FALSE;

		m_lstInfo.AddString("رͨ0");
	}
	
}

void CJVSDKDEMODlg::OnButtonOpenPreview() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened)
	{
		RECT rt;
		if (g_config.bInitPreview)
		{
			this->GetWindowRect(&rt);
			rt.left += 13;
			rt.right = rt.left + 352;//352;
			rt.top += 32;
			rt.bottom = rt.top + 288;//288;
			JVS_SetVideoPreview(0, this->GetSafeHwnd(), &rt, TRUE);
			m_bInit	=	TRUE;
			g_config.Channel[0].bVideoPreview = TRUE;
			JVS_SetOSD(0, 1, (PUCHAR)"1ͨ", TRUE);
			m_lstInfo.AddString("0ͨʼԤ");
		}
	}
}

void CJVSDKDEMODlg::OnButtonStopPreview() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened)
	{
		JVS_SetVideoPreview(0, this->GetSafeHwnd(), NULL, FALSE);
		g_config.Channel[0].bVideoPreview = FALSE;
		m_lstInfo.AddString("0ֹͨͣԤ");
	}
	
}

void CJVSDKDEMODlg::OnButtonStartCompress() 
{
	// TODO: Add your control notification handler code here
	PCHANNEL pChannel = &g_config.Channel[0];

	if (pChannel->bOpened)
	{
		//֪ͨͻµͼС
		if (pChannel->bTransmitting)
		{
			//ڸͼСŷʹϢ
			((CJvsSock *)pChannel->hSocket)->SendFrameSize();
		}

		JVS_StartCompress(0);
		g_config.Channel[0].bCompress = TRUE;
		m_lstInfo.AddString("0ͨʼѹ");

		//ݷãdemoʾһ
		if (pChannel->fAnalyse == NULL)
		{
			pChannel->fAnalyse = fopen("analyse.txt", "wt");
		}
	}
	
}

void CJVSDKDEMODlg::OnButtonStopCompress() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened)
	{
		g_config.Channel[0].bCompress = FALSE;
		JVS_StopCompress(0, TRUE);
		m_lstInfo.AddString("0ֹͨͣѹ");
		if (g_config.Channel[0].fAnalyse)
		{
			fclose(g_config.Channel[0].fAnalyse);
			g_config.Channel[0].fAnalyse = NULL;
		}
	}
	
}


void CJVSDKDEMODlg::OnButtonWrite() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened == FALSE)
		return;

	if (g_config.Channel[0].fout == NULL)
	{
		if ((g_config.Channel[0].fout = fopen("test300.901", "wb")) == NULL)
		{
			m_lstInfo.AddString("ļʧ");
		}
		else
		{
			JVS_GetHeaderData(0, &g_config.Channel[0].headerData);
			g_config.Channel[0].headerData.i_total_frames = 0;
			//д˫ļͷṹ
			fwrite(&g_config.Channel[0].headerData, sizeof(JVS_HEADER), 1, g_config.Channel[0].fout);
			fwrite(&g_config.Channel[0].headerData, sizeof(JVS_HEADER), 1, g_config.Channel[0].fout);
			g_config.Channel[0].bWriteOK = TRUE;
			JVS_InsertKeyFrame(0);	//ļһؼ֡
			m_lstInfo.SetCurSel(m_lstInfo.AddString("ļtest300.901"));
		}
	}
}

void CJVSDKDEMODlg::OnButtonStopWrite() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].fout)
	{
		g_config.Channel[0].bWriteOK = FALSE;
		//ļͷĵڶļͷṹдͷ
		fseek(g_config.Channel[0].fout, sizeof(JVS_HEADER), SEEK_SET);
		fwrite(&g_config.Channel[0].headerData, sizeof(JVS_HEADER), 1, g_config.Channel[0].fout);
		fclose(g_config.Channel[0].fout);
		g_config.Channel[0].fout = NULL;
		m_lstInfo.SetCurSel(m_lstInfo.AddString("رļ"));
	}
}

void CJVSDKDEMODlg::OnButtonEnableOsd() 
{
	// TODO: Add your control notification handler code here
	JVS_SetOSD(0, 1, (PUCHAR)"2ͨ", TRUE);
}

void CJVSDKDEMODlg::OnButtonDisableOsd() 
{
	// TODO: Add your control notification handler code here
	JVS_SetOSD(0, 1, NULL, FALSE);
}


void CJVSDKDEMODlg::OnButtonQp() 
{
	// TODO: Add your control notification handler code here
	int nQp = GetDlgItemInt(IDC_EDIT_QP);
	if (nQp == 0)
		JVS_SetQualityMode(0, nQp, 50);
	else if (nQp == 1)
		JVS_SetQualityMode(0, nQp, 150);
	else
		JVS_SetQualityMode(0, nQp, 300);
	CString s;
	s.Format("ѹ:%d", nQp);
	m_lstInfo.SetCurSel(m_lstInfo.AddString(s));
}

void CJVSDKDEMODlg::OnButtonFullScreen() 
{
	// TODO: Add your control notification handler code here
	JVS_SetVideoPreview(0, this->GetSafeHwnd(), NULL, FALSE);
	CFull cd;
	cd.DoModal();
	if (g_config.bInitPreview)
	{
		RECT rt;
		this->GetWindowRect(&rt);
		rt.left += 13;
		rt.right = rt.left + 352;
		rt.top += 32;
		rt.bottom = rt.top + 288;
		JVS_SetVideoPreview(0, this->GetSafeHwnd(), &rt, TRUE);
	}
}

//SDKʹõĴѹݵĻص
void FuncGetDataCallback(int nChannel, PUCHAR pData, UINT nBuffLen, PUCHAR pData2, UINT nBuffLen2, int nFrameType, BOOL bMov)
{
	//Ƿյƶź
	if (bMov)
	{
		Beep(1000, 1);
	}
	PCHANNEL pChannel = &g_config.Channel[nChannel];
	//¼
	if (pChannel->bWriteOK && pChannel->fout)
	{
		if (nFrameType != JVS_TYPE_AUD)
			pChannel->headerData.i_total_frames ++;
		fwrite(pData, nBuffLen, 1, pChannel->fout);
	}
	//
	if (pChannel->bTransmitting)
	{
		((CJvsSock *)pChannel->hSocket)->SendFrameData(pData2, nBuffLen2, nFrameType);
	}

	//ݷãdemoʾ
	if (pChannel->fAnalyse)
	{
		if (nFrameType == JVS_TYPE_IDR)
			fwrite("ؼ֡", 1, 8, pChannel->fAnalyse);
		char acBuff[128];
		_itoa( nBuffLen, acBuff, 10 );
		fwrite(acBuff, 1, strlen(acBuff), pChannel->fAnalyse);
		if (nFrameType == JVS_TYPE_SKIP)
		{
			sprintf(acBuff, "(SKIP):%x-%x,%x,%x,%x", *(int *)&pData[4], pData[8], pData[9], pData[10], pData[11]);
			fwrite(acBuff, 1, strlen(acBuff), pChannel->fAnalyse);
		}
		fwrite("\n", 1, 1, pChannel->fAnalyse);
	}
}

void CJVSDKDEMODlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	
	// TODO: Add your message handler code here
	if (m_bInit)
	{
		RECT rt;
		GetWindowRect(&rt);
		rt.left += 13;
		rt.right = rt.left + 352;
		rt.top += 32;
		rt.bottom = rt.top + 288;
		if (g_config.Channel[0].bVideoPreview == TRUE)
			JVS_SetVideoPreview(0, GetSafeHwnd(), &rt, TRUE);
	}
	
}

void CJVSDKDEMODlg::OnButtonBitmap() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened == FALSE)
		return;

	//ӦóԼ֤СССSDK
	if (g_config.Channel[0].Bitmap.pRGB != NULL)
	{
		return;	//Ѿ˵һץͼûн
	}

	JVS_GetBitmapSize(0, &g_config.Channel[0].Bitmap.dwWidth,&g_config.Channel[0].Bitmap.dwHeight);

	g_config.Channel[0].Bitmap.pRGB = new UCHAR[g_config.Channel[0].Bitmap.dwWidth * g_config.Channel[0].Bitmap.dwHeight * 4];
	if (g_config.Channel[0].Bitmap.pRGB)
	{
		JVS_GetBitmap(0, g_config.Channel[0].Bitmap.pRGB);
	}
	
}

LRESULT CJVSDKDEMODlg::OnSDKNotify(WPARAM wParam, LPARAM lParam)
{
	if (lParam == JVS_WM_COPYRIGHT)
	{
		//Ӧͨͨ˰Ȩ֤ԶȡͨĳڡкšGUIDŵ
		int nChannel = wParam;
		ULONG ulSN = JVS_GetChannelSN(nChannel);
	}
	else if (lParam == JVS_WM_BITMAP_OK)		//SDKץͼ֪ͨ
	{
		int nChannel = wParam;
		if (nChannel<0 || nChannel > JDVR_MAX_CHANNEL)
		{
			return FALSE;
		}
		if (g_config.Channel[nChannel].Bitmap.pRGB == NULL)
		{
			return FALSE;
		}
		int nWidth = g_config.Channel[0].Bitmap.dwWidth;
		int nHeight = g_config.Channel[0].Bitmap.dwHeight;
		int nBits = 4;
		ULONG ulSize = nWidth * nHeight * nBits;
		FILE * fout = fopen("bitmap.bmp", "wb");
		if (fout)
		{
			BITMAPFILEHEADER bmHeader;
			memset(&bmHeader, 0, sizeof(bmHeader));
			bmHeader.bfType = 0x4D42;
			bmHeader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + nWidth * nHeight * nBits;
			bmHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

			BITMAPINFOHEADER bmInfo;
			memset(&bmInfo, 0, sizeof(bmInfo));
			bmInfo.biSize = sizeof(bmInfo);
			bmInfo.biWidth	=	nWidth;
			bmInfo.biHeight	=	nHeight;
			bmInfo.biPlanes	=	1;
			bmInfo.biBitCount	=	nBits * 8;
			bmInfo.biCompression	=	0;
			bmInfo.biSizeImage	=	nWidth * nHeight * nBits;
			bmInfo.biXPelsPerMeter	=	300;
			bmInfo.biYPelsPerMeter	=	300;

			fwrite(&bmHeader, sizeof(bmHeader), 1, fout);
			fwrite(&bmInfo, sizeof(bmInfo), 1, fout);
			fwrite(g_config.Channel[nChannel].Bitmap.pRGB, nWidth * nHeight * nBits, 1, fout);

			fclose(fout);
			m_lstInfo.SetCurSel(m_lstInfo.AddString("ץͼɹǰĿ¼µbitmap.bmp"));
			//ͷRGB
			delete[] g_config.Channel[nChannel].Bitmap.pRGB;
			g_config.Channel[nChannel].Bitmap.pRGB = NULL;
		}
	}
	return TRUE;
}

void CJVSDKDEMODlg::OnButtonNetwork() 
{
	// TODO: Add your control notification handler code here
	if (m_pSocket)
	{
		m_lstInfo.AddString("Ѿ");
		return;
	}

	//
	CJvsSock * pSocket = new CJvsSock;
	if (pSocket->Create(9100, SOCK_DGRAM))
	{
		int nSize = 128 * 1024;
		pSocket->SetSockOpt(SO_SNDBUF, &nSize, sizeof(int));
		m_pSocket = pSocket;
		pSocket->m_nChannel = 0;
		pSocket->m_hParent = this;
		g_config.Channel[0].hSocket = pSocket;
		m_lstInfo.AddString("紫ɹ");
	}
	else
	{
		delete pSocket;
		m_lstInfo.AddString("紫ʧܣ" );
	}
	
}

void CJVSDKDEMODlg::OnCheckMovDetect() 
{
	// TODO: Add your control notification handler code here
	if (((CButton *)GetDlgItem(IDC_CHECK_MOV_DETECT))->GetCheck())
	{
		JVS_SetMovDetect(0, GetDlgItemInt(IDC_EDIT_MOV_GRADE), GetDlgItemInt(IDC_EDIT_MOV_THRESHOLD), 48, 0, NULL);
	}
	else
	{
		//nSceneCut=0ʱرƶ
		JVS_SetMovDetect(0, 0, 0, 0, 0, NULL);
	}
	//ƶúѹʹµЧ
}

void CJVSDKDEMODlg::OnCheckAudioPreview() 
{
	// TODO: Add your control notification handler code here
	if (((CButton *)GetDlgItem(IDC_CHECK_AUDIO_PREVIEW))->GetCheck())
	{
		JVS_SetAudioPreview(0, this->GetSafeHwnd(), TRUE);
	}
	else
	{
		JVS_SetAudioPreview(0, NULL, FALSE);
	}
	
}

void CJVSDKDEMODlg::OnCheckAudioCompress() 
{
	// TODO: Add your control notification handler code here
	//ULONG ul = JVS_GetVolume(0);
	JVS_SetAudioCompress(0, ((CButton *)GetDlgItem(IDC_CHECK_AUDIO_COMPRESS))->GetCheck());
}

void CJVSDKDEMODlg::OnButtonSetMode() 
{
	// TODO: Add your control notification handler code here
	DWORD dwPixeMode = m_comboMode.GetCurSel();
	BOOL bCompress = g_config.Channel[0].bCompress;
	BOOL bVideoPreview = g_config.Channel[0].bVideoPreview;

	if (g_config.Channel[0].dwPixelMode != dwPixeMode)
	{
		if (g_config.Channel[0].fout != NULL)
		{
			m_lstInfo.AddString("Ƶֱʷ˸ı䣬ԭ¼ļֹͣ¼");
			OnButtonStopWrite();
		}
		if (bVideoPreview == TRUE)
		{
			OnButtonStopPreview();
		}
		if (bCompress == TRUE)
		{
			OnButtonStopCompress();
		}
		JVS_SetVideoPixelMode(0, dwPixeMode);
		if (bVideoPreview == TRUE)
		{
			OnButtonOpenPreview();
		}
		if (bCompress == TRUE)
		{
			OnButtonStartCompress();
		}
		g_config.Channel[0].dwPixelMode = dwPixeMode;
	}
}


void CJVSDKDEMODlg::OnButtonCapFile() 
{
	// TODO: Add your control notification handler code here
	if (g_config.Channel[0].bOpened == FALSE)
		return;

	JVS_GetBitmapFile(0, (PUCHAR)"bitmap2.bmp", 0);
	
}
