// SimpleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Simple.h"
#include "SimpleDlg.h"
#include "JVSDK.h"
#pragma comment(lib,"JVSDK.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSimpleDlg dialog

CSimpleDlg::CSimpleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSimpleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSimpleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_bOpened = FALSE;
}

void CSimpleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSimpleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSimpleDlg, CDialog)
	//{{AFX_MSG_MAP(CSimpleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN_CARD, OnButtonOpenCard)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_OPEN_PREVIEW, OnButtonOpenPreview)
	ON_BN_CLICKED(IDC_BUTTON_CAP_BITMAP, OnButtonCapBitmap)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_PREVIEW, OnButtonClosePreview)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_CARD, OnButtonCloseCard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimpleDlg message handlers

BOOL CSimpleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	m_nTotalChannel = JVS_InitSDK();//ڳʼӦóʱʼSDK
	if (m_nTotalChannel == 0)
	{
		MessageBox("ûп");
	}
	else
	{
		JVS_InitPreview();	//ʼԤԴ
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSimpleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSimpleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSimpleDlg::OnButtonOpenCard() 
{
	// TODO: Add your control notification handler code here
	if (m_nTotalChannel != 0)
	{
		m_bOpened = JVS_OpenChannel(0);
		if (m_bOpened)
		{
			//OSD
			JVS_SetOSD(0, 1, (PUCHAR)"channel 0", TRUE);
		}
	}
	
}

void CSimpleDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here

	JVS_ReleasePreview();	//ͷԤԴ
	JVS_ReleaseSDK();		//ͷSDK
	
}

void CSimpleDlg::OnButtonOpenPreview() 
{
	// TODO: Add your control notification handler code here
	if (m_bOpened)
	{
		RECT rt;
		GetWindowRect(&rt);
		rt.left += 13;
		rt.right = rt.left + 352;//352;
		rt.top += 32;
		rt.bottom = rt.top + 288;//288;
		JVS_SetVideoPreview(0, this->GetSafeHwnd(), &rt, TRUE);
	}
	
}

void CSimpleDlg::OnButtonCapBitmap() 
{
	// TODO: Add your control notification handler code here
	if (m_bOpened)
	{
		if (JVS_GetBitmapFile(0, (PUCHAR)"bitmap2.bmp", 1) == TRUE)
			MessageBox("ɹǰĿ¼µbitmap2.bmp");
		else
			MessageBox("ץͼʧܣ");
	}
	
}

void CSimpleDlg::OnButtonClosePreview() 
{
	// TODO: Add your control notification handler code here
	if (m_bOpened)
	{
		JVS_SetVideoPreview(0, NULL, NULL, FALSE);
	}
	
}

void CSimpleDlg::OnButtonCloseCard() 
{
	// TODO: Add your control notification handler code here
	if (m_bOpened)
	{
		JVS_CloseChannel(0);
		m_bOpened = FALSE;
	}
	
}
